/**********************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors: 
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.cosmos.rm.validation.internal.smlvalidators;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

import org.eclipse.cosmos.rm.validation.internal.core.AbstractSMLValidator;
import org.eclipse.cosmos.rm.validation.internal.core.MainValidator;
import org.eclipse.cosmos.rm.validation.internal.databuilders.DataBuilderRegistry;
import org.eclipse.cosmos.rm.validation.internal.databuilders.DocumentDOMBuilder;
import org.eclipse.cosmos.rm.validation.internal.databuilders.IDataBuilder;
import org.eclipse.cosmos.rm.validation.internal.databuilders.SMLKeyUniqueBuilder;

/**
 * This class is used to validate SML key and unique extension 
 * 
 * @author popescu
 */
public class SMLKeyUniqueValidator extends AbstractSMLValidator
{
	/**
	 * Constructor
	 */
	public SMLKeyUniqueValidator()
	{
	}
	
	/**
	 * @see org.eclipse.cosmos.rm.validation.internal.launcher.IValidator#initialize(java.util.Map)
	 */
	public void initialize(Map validationAttribute)
	{
		super.initialize(validationAttribute);
		
		/* Register the right data builders with the registry */
		DataBuilderRegistry databuilderRegistry = DataBuilderRegistry.instance();
		databuilderRegistry.registerDataStructureBuilder(SMLKeyUniqueBuilder.ID, new SMLKeyUniqueBuilder());
	}
	

	/**
	 * @see org.eclipse.cosmos.rm.validation.internal.launcher.IValidator#validate()
	 */
	public boolean validate()
	{
		/* Start the validation process for the SML Key constraints */		
		DataBuilderRegistry databuilderRegistry = DataBuilderRegistry.instance();
		IDataBuilder dataBuilder = databuilderRegistry.getDataStructureBuilder(SMLKeyUniqueBuilder.ID);
			
		Iterator smlkeyTypes = dataBuilder == null ? null : ((HashMap)dataBuilder.getDataStructure()).keySet().iterator();
		while(smlkeyTypes.hasNext())
		{
			System.out.println("SML key validator " + smlkeyTypes.next());
		}
		
//		IValidationOutput output = getValidationOutput();		
				
		return true;
	}
	
	
	public static void main(String[] args)
	{
		final String RESOURCE = "d://InValidKeyDuplicate.xml";
		
		MainValidator validator = new MainValidator();
		validator.start(RESOURCE);
		
		//Object obj = DocumentDOMBuilder.getInstance().getDataStructure();
		//System.out.println(obj);
		
		
	}
	
}
